var gulp = require('gulp');
var gts = require('gulp-typescript');

function compileSource(tsConfig, options) {
  options = options || {};
  options.jsx = options.jsx || "react";
  var tsProject = gts.createProject(tsConfig, options);
  console.log("Compile - Typescript version " + tsProject.typescript.version + " :: " + tsConfig);
  return tsProject.src().pipe(gts(tsProject));
}

function compile(name, tsConfig, outputFolder, options) {
  return compileSource(tsConfig, options)[name].pipe(gulp.dest(outputFolder));
}

var tsCompiler = {
  ts: function(tsConfig, outputFolder, options) {
    return compile("js", tsConfig, outputFolder, options);
  },

  dts: function(tsConfig, outputFolder, options) {
    return compile("dts", tsConfig, outputFolder, options);
  }
}
module.exports = tsCompiler;
